Thermostat Tools for Eclipse
============================

*Thermostat Tools for Eclipse* is an [eclipse][1] plugin to help create
[Thermostat][2] [plugins][3]. It helps by automating the tedious and
error-prone parts of creating thermostat plugins, including the creation of a
simple project strucuture, support for creating and modifying
`thermostat-plugin.xml` files and exporting a complete plugin so it can be used
by a Thermostat installation.

- Website: http://icedtea.classpath.org/hg/thermostat-tools-eclipse
- IRC: irc://freenode.net/thermostat
- Mailing List: thermostat@icedtea.classpath.org

Features
--------

*Thermostat Tools for Eclipse* provides extensive support for creating plugins
for Thermostat.

*Thermostat Tools for Eclipse* provides support for creating, modifying,
buliding and exporting Thermostat plugin projects. It creates a default project
structure matching that of most of the plugins that are included with
Thermostat and builds them automatically using `maven`.

*Thermostat Tools for Eclipse* provides a GUI editor for manipulating
`thermostat-plugin.xml` files. After installing the plugin, eclipse will open
all `thermostat-plugin.xml` files (with the correct xml header) using the GUI
editor.

With the GUI editor you can easily add, remove and edit commands and extensions
that are listed in the `themrostat-plugin.xml` file.

*Thermostat Tools for Eclipse* provides also provides an export wizard to make
it easy to install a plugin so it can be picked up and used by Thermostat.

Building
--------

*Thermostat Tools for Eclipse* uses [maven][4]/[tycho][5] to build. You will
need maven installed before you can build.

To build use:

    mvn clean verify

This will download any dependencies needed and build the eclipse
plugin and run all tests.

Installing
----------

### From a source build

After building as described in the previous section, a p2 repository will be
generated at
`com.redhat.thermostat.tools.eclipse.plugin-p2-repo/target/repository`. Point
eclipse to this directory as an update site and then install the
`com.redhat.thermostat.tools.eclipse.plugin` plugin.

### From a nightly build

You can also use the nightly builder as an update site. Point eclipse to
`http://builder.classpath.org/jenkins/job/Thermostat Tools For Eclipse/lastSuccessfulBuild/artifact/com.redhat.thermostat.tools.eclipse.plugin-p2-repo/target/repository/`
as an update site and then install the `com.redhat.thermostat.tools.eclipse` plugin.

Running
-------


Once the plugin is installed, new options will appear in a number of places in Eclipse.

You can create a new plugin project using `File -> New -> Other` dialog:
`Thermostat Plugin Project`. This will create an appropriate set of projects
with dependencies all set up. It will include a simple `thermostat-plugin.xml`
file. The project can be exported as a plugin using the export wizard into a
Thermostat installation.

Once the plugin is installed, a new option will appear in the `File -> New ->
Other` dialog: Thermostat Plugin Descriptor. This will create a new
`thermostat-plugin.xml` and bring up the GUI editor for it.

Any existing `thermostat-plugin.xml` files will also be opened with the GUI
editor.

Contributing
------------

Please see [HACKING.md](HACKING.md) for code structure, conventions and style.
[TODO.md](TODO.md) contains a list of tasks that need doing.

License
-------

*Thermostat Tools for Eclipse* is licensed under GPLv2+ with Classpath Exception.
Please see the [LICENSE](LICENSE) for more details.

[1]: http://eclipse.org

[2]: http://icedtea.classpath.org/thermostat

[3]: http://icedtea.classpath.org/wiki/Thermostat/ExtensionTutorial

[4]: http://maven.apache.org/

[5]: http://eclipse.org/tycho/
